SystemOrganization addCategory: #'Glamour-Examples'!

TestCase subclass: #GLMFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMFileTest methodsFor: 'accessing' stamp: 'DamienCassou 9/23/2009 08:16'!
anyRoot
	^ GLMFile anyRoot! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/2/2009 19:21'!
testGetASlashAtTheEndOfDirectoryNames
	self assert: (self anyRoot files allSatisfy: [:file | file isFile or: [file nameDistinguishingTypes last = $/]])! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/2/2009 19:15'!
testNameIsNeverEmpty
	self assert: (self anyRoot files allSatisfy: [:file | file name notEmpty])! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/2/2009 19:17'!
testNamesAreDifferent
	self assert: (self anyRoot files collect: [:file | file name]) asSet size equals: (self anyRoot files size)! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/23/2009 08:16'!
testRootNameIsNeverEmpty
	self assert: (GLMFile roots allSatisfy: [:file | file name notEmpty])! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/23/2009 08:16'!
testRootsAreDirectories
	self assert: (GLMFile roots allSatisfy: [:ea | ea isDirectory])! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/23/2009 08:15'!
testRootsAreSFile
	self assert: (GLMFile roots allSatisfy: [:root | root isKindOf: GLMFile])! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/2/2009 19:05'!
testThereAreSomeDirectoriesUnderRoot
	self assert: (self anyRoot files anySatisfy: [:file | file isDirectory])! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/2/2009 19:06'!
testThereAreSomeFilesUnderRoot
	self assert: (self anyRoot files anySatisfy: [:file | file isFile])! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/23/2009 08:15'!
testThereAreSomeRoots
	self assert: GLMFile roots notEmpty.
	! !

Object subclass: #GLMCodeBrowser
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMCodeBrowser classSide methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:49'!
defaultEnvironment
	^ GLMSTModel defaultEnvironment! !

!GLMCodeBrowser classSide methodsFor: 'opening' stamp: 'DamienCassou 9/13/2009 11:01'!
open
	^ self new
		open! !

!GLMCodeBrowser methodsFor: 'accessing' stamp: 'DamienCassou 9/13/2009 11:21'!
browser
	^ browser ifNil: [self buildBrowser. browser]! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'tg 9/19/2009 23:49'!
buildBrowser
	browser := GLMTableLayoutBrowser new.
	browser title: 'Glamorous ST Browser'.
	self layout.
	self onPackages.
	self onClassesFromPackages.
	self onInstVarsFromClasses.
	self onMethodsFromClasses.
	self onMethodsFromInstVars.
	self onDetailsFromPackagesFromClassesFromMethods.
	browser sendTo: #outer->#focusOnMethod from: #details->#focusOnMethod with: [:m | m ].
	browser sendTo: #packages->#selection from: #outer->#focusOnMethod with: [:method | method glmBehavior glmPackage].
	browser sendTo: #classes->#selection from: #outer->#focusOnMethod with: [:method | method glmBehavior ].
	browser sendTo: #methods->#selection from: #outer->#focusOnMethod with: [:method | method ]! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'tg 9/18/2009 09:36'!
layout
	browser
		column: #packages;
		column: [:c | c row: #classes; row: #instVars ];
		column: [:c | c row: #methods; row: #details] span: 3.! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'tg 9/18/2009 11:49'!
onClassesFromPackages
	browser
		showOn: #classes; from: #packages;
		using: [browser tree
					when: [:package | package isCollection not];
					display: [:package | package allClasses];
					children: [ :each | each traits ];
					icon: [ :each | 
						each stBehavior theNonMetaClass browserIcon isNil ifFalse: 
							[ OBMorphicIcons iconNamed: each stBehavior theNonMetaClass browserIcon ]
						ifTrue: [ nil ] ];
					format: [:class | class name]]! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'tg 10/17/2009 16:40'!
onDetailsFromPackagesFromClassesFromMethods
	browser
		showOn: #details; from: #classes; from: #methods; from: #packages; 
		using: [
			browser text
					forSmalltalk: [:class | class stBehavior ];
					title: 'Method';
					display: [:class :method | method sourceCode ].
			browser text
					forSmalltalk;
					title: 'Class';
					useExplicitNotNil;
					when: [:class | class notNil ];
					display: [:class | class definition ].
			browser list
					title: 'References';
					useExplicitNotNil;
					when: [:class | class notNil ];
					display: [:class | class references];
					format: [:each | each glmBehavior name, '>>', each name];
					update: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ].
			browser list
					title: 'Senders';
					display: [:class :method | method senders];
					format: [:each | each glmBehavior name, '>>', each name];
					update: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ].
			browser list
					title: 'Implementors';
					display: [:class :method | method implementors];
					format: [:each | each glmBehavior name, '>>', each name];
					update: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ].
		]! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'tg 10/23/2009 08:13'!
onInstVarsFromClasses
	browser showOn: #instVars; from: #classes; using: [ 
		browser tree
				display: [ :class | class instVars ];
				tags: [ :each | 
					{ each glmBehavior isMetaSide ifTrue: ['META'] ifFalse: ['INST'] } ] ]! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'tg 10/23/2009 08:13'!
onMethodsFromClasses
	browser showOn: #methods; from: #classes; using: [ 
		browser tree
				display: [ :class | class instanceAndMetaMethods ];
				tags: [ :each | 
					{each glmCategory name.
					each glmBehavior isMetaSide ifTrue: ['META'] ifFalse: ['INST']} ] ]! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'tg 10/23/2009 08:13'!
onMethodsFromInstVars
	browser showOn: #methods; from: #instVars; using: [ 
		browser tree
				display: [ :var | var accessingMethods ];
				tags: [ :each | 
					{each glmCategory name.
					each glmBehavior isMetaSide ifTrue: ['META'] ifFalse: ['INST']} ] ]! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'tg 10/17/2009 17:08'!
onPackages
	browser
		showOn: #packages;
		using: 
			[ browser tree
				children: [ :package | package subPackages ];
				format: [ :package | package name ];
				filterOn: [ :text :each | text match: each name ] ]! !

!GLMCodeBrowser methodsFor: 'opening' stamp: 'DamienCassou 9/14/2009 09:04'!
open
	^ self browser openOn: (GLMSTPackage rootPackagesOn: self class defaultEnvironment)! !

Object subclass: #GLMExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

GLMExamples subclass: #GLMBasicExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMBasicExamples commentStamp: 'tg 9/11/2009 15:57' prior: 0!
self browseExamples!

!GLMBasicExamples methodsFor: 'private' stamp: 'tg 7/31/2009 22:55'!
actionsFor: aPresentation 
	|actions|
	aPresentation isMultiple 
							ifTrue: [actions := (aPresentation selection) ifNil: [OrderedCollection new]]
							ifFalse: [actions := OrderedCollection with: aPresentation selection ].
	^ actions collect: [:i |
					(GLMAction new) 
						action: [:each | Transcript show: 'Menu - Item', i printString; cr]; 
						title: 'Menu - Item', i printString; 
						yourself ]! !

!GLMBasicExamples methodsFor: 'file examples' stamp: 'tg 9/11/2009 15:38'!
fileExplorer
	<glmBrowser: 'File Explorer' input: 'FileDirectory default'>
	"self new fileExplorer openOn: FileDirectory default"
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser 
		column: #folders;
		column: [ :col | col row: #files span: 2; row: #preview ] span: 2. 
	browser showOn: #folders; using: [
		browser tree 
			title: 'Folders'; 
			children: [ :fd | fd directoryNames collect: [ :each | FileDirectory on: fd pathName, fd pathNameDelimiter asString, each ] ]; 
			format: [ :folder | folder localName ] ].
	browser showOn: #files; from: #folders; using: [
		browser list 
			format: [ :fd | fd localName ]; 
			display: [ :fd | fd fileNames collect: [:each | FileDirectory on: fd pathName, fd pathNameDelimiter asString, each ] ] ].
	browser showOn: #preview; from: #files; using: [
		browser text
			display: [ :file | (FileStream readOnlyFileFullyNamed: file fullName) contents ] ].
	^ browser! !

!GLMBasicExamples methodsFor: 'file examples' stamp: 'tg 9/11/2009 15:43'!
fileFinder
	<glmBrowser: 'File Finder' input: 'FileDirectory default'>
	"self new fileFinder openOn: FileDirectory default"

	| browser |
	browser := GLMFinder new.
	browser list
		display: [ :fd | fd entries collect: [:each | FileDirectory on: fd pathName, fd pathNameDelimiter asString, each name]];
		format: [ :fd | fd localName ];
		when: [ :fd | fd directoryEntry isDirectory ].
	browser text
		display: [ :fd | (FileStream readOnlyFileFullyNamed: fd fullName) contents ];
		when: [ :fd | fd directoryEntry isDirectory not ].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 10/26/2009 02:08'!
fixSizePanes
	"self new fixSizePanes openOn: 1"
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser column: #fix size: 10; column: #variable.
	browser showOn: #fix; using: [browser text display: 'Fix size'].
	browser showOn: #variable; using: [browser text display: 'Variable size'].
	^ browser ! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 9/11/2009 15:53'!
interdependentPanes
	<glmBrowser: 'Inter-dependent Panes' input: '5'>
	"self new interdependentPanes openOn: 5"
	|browser |

	browser := GLMTableLayoutBrowser new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser list
			display: [:x | 1 to: x * 3]].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x * 3]].
	browser showOn: #one; from: #two; using: [
		browser list
			display: [:x | 1 to: x * 3]].
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 10/2/2009 01:21'!
listsWithUpdatedSelection
	"self new listsWithUpdatedSelection openOn: 10"
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser column: #one; column: #two; column: #three.
	browser showOn: #one; using: [
		browser list
			display: [:x | 1 to: x ]].
	browser showOn: #two; using: [
		browser list
			display: [:x | 1 to: x + 2 ]].
	browser showOn: #three; using: [
		browser list
			beMultiple;
			display: [:x | 1 to: x ]].
	browser sendTo: #two->#selection from: #one with: [:x | x + 2].
	browser sendTo: #one->#selection from: #two with: [:x | x - 2].
	browser sendTo: #three->#selection from: #two with: [:x | (1 to: (x - 2)) ].
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 9/9/2009 02:15'!
multiInitialSelection
	"
		| browser |
		browser := self new multiInitialSelection.
		browser openOn: 5.
		(browser panes first port: #selection) value: #(2 5 3).
	"
	|browser |

	browser := GLMTableLayoutBrowser new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser list
			beMultiple;
			display: [:x | 1 to: x * 3]].
	browser showOn: #two; from: #one; using: [
		browser list ].
	^ browser! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'tg 10/5/2009 00:35'!
multipleFinderWithSearch
	<glmBrowser: 'Multiple List with Menu and Search' input: '$a to: $z'>
	"self new multipleFinderWithSearch openOn: ($a to: $z)"

	| finder |	
	finder := GLMFinder new.
	finder tree
			title: 'List';
			beMultiple;
			actions: [:list | self actionsFor: list];
			filterOn: [:text :list | list select: (Compiler evaluate: '[:each | ', text, ']')].
	finder tree
			title: 'Tree';
			actions: [:list | self actionsFor: list];
			filterOn: [:text :each | (Compiler evaluate: '[:each | ', text, ']') value: each].
	^ finder ! !

!GLMBasicExamples methodsFor: 'tabs examples' stamp: 'tg 9/30/2009 23:50'!
multipleTabs
	<glmBrowser: 'Multiple Tabs' input: '1'>
	"self new multipleTabs openOn: 1"
	
	| finder |
	finder := GLMFinder new.
	(1 to: 3) do: [:i | 
		finder text
			title: i printString;
			display: [:x | i printString].
		finder text
			titleIcon: MenuIcons smallFindIcon;
			display: [:x | i printString]
	].
	
	^ finder! !

!GLMBasicExamples methodsFor: 'pier examples' stamp: 'tg 8/31/2009 14:20'!
pierFinder
	"
		self new pierFinder openOn: PRKernel instances anyOne root.
	"
	| browser |
	browser := GLMFinder new.
	browser list
		display: [:each | each enumerator contents];
		format: [:each | each title];
		title: 'Navigation'.
	browser magritte title: 'Editor'.
	browser mondrian
			title: 'Tree';
			painting: [:view :each | 
				view nodeShape: (MORectangleShape withBorder height: [:x | x plainText size // 10]).
				view nodes: each enumerator everything contents.
				view edgesFrom: #parent.
				view treeLayout].
	^ browser! !

!GLMBasicExamples methodsFor: 'pier examples' stamp: 'tg 5/6/2009 13:31'!
pierTreeEditor

	"
		self new pierTreeEditor openOn: PRKernel instances anyOne root.
	"

	| browser |
	browser := GLMTableLayoutBrowser new.
	browser column: #navigation; column: #editor span: 4.
	browser showOn: #navigation; using: [
		browser tree
			children: [:each | each enumerator contents];
			format: [:each | each title ];
			title: 'Navigation'.
	].
	browser showOn: #editor; from: #navigation; using: [
		browser magritte
			title: 'Editor'.
	].
	^ browser ! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'tg 9/11/2009 16:00'!
simpleFinderWithMenu
	<glmBrowser: 'Finder with Menu' input: '$z'>
	"self new simpleFinderWithMenu openOn: $z"

	| finder |
	finder := GLMFinder new.
	finder list
			title: 'List';
			display: [:each | $a to: each];
			actions: [:list | self actionsFor: list ].
	^ finder! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 9/21/2009 23:10'!
singleInitialSelection
	"
		| browser |
		browser := self new singleInitialSelection.
		browser openOn: 5.
		(browser panes first port: #selection) value: 3.
	"
	|browser |

	browser := GLMTableLayoutBrowser new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser list
			display: [:x | 1 to: x];
			format: [:number | Text string: number printString attribute: TextColor red]].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x * 2]].
	^ browser! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'tg 9/11/2009 15:59'!
staticAndDynamicMenu
	<glmBrowser: 'Static and Dynamic Menu' input: '$z'>
	"self new staticAndDynamicMenu openOn: $z"

	| finder |
	finder := GLMFinder new.
	finder list
			title: 'List';
			display: [:each | $a to: each];
			actions: [:list | self actionsFor: list ];
			act: [Transcript show: 'static action'; cr] entitled: 'Static action';
			act: [Transcript show: 'static sub action'; cr] entitled: 'Static sub action' categorized: 'Sub menu'.
	finder text
			title: 'Text';
			display: [:each | 'Character ', each asString];
			actions: [:text | OrderedCollection with: (GLMAction new title: 'Print selection'; action: [Transcript show: text selection]; yourself) ];
			act: [Transcript show: 'Text static action'] entitled: 'Static action'.
	^ finder! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 10/2/2009 12:51'!
taggedTree
	<glmBrowser: 'Tagged Tree' input: '#(1 2 3 4 5)'>
	"self new taggedTree openOn: #(1 2 3 4 5)"
	|browser |

	browser := GLMTableLayoutBrowser new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			tags: [:each | 
				{each even ifTrue: ['even'] ifFalse: ['odd'].
				each even ifTrue: ['x'] ifFalse: ['y']}
				]].
	browser showOn: #two; from: #one; using: [
		browser text
			display: [:x | 'You have selected ', x printString ]].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 11/1/2009 21:14'!
threeInterdependentPanes
	<glmBrowser: 'Inter-dependent Panes' input: '5'>
	"self new threeInterdependentPanes openOn: 5"
	|browser |

	browser := GLMTableLayoutBrowser new.
	browser column: #one; column: #two; column: #three.
	browser showOn: #one; using: [
		browser tree
			display: [:x | 1 to: x]].
	browser showOn: #two; from: #one; using: [ 
		browser tree
			display: [:x | 1 to: x*2]].
	browser showOn: #three; from: #two; using: [
		browser tree
			display: [:x | 1 to: x*3];
			update: #focus on: $f entitled: 'Focus' with: [:list | list selection] ].
	browser sendTo: #outer->#focus from: #three->#focus with: [:x | x ].
	browser sendTo: #one->#selection from: #outer->#focus with: [:x | x ].
	browser sendTo: #two->#selection from: #outer->#focus with: [:x | x ].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 9/30/2009 14:04'!
treeWithAmountFiltering
	"self new treeWithAmountFiltering openOn: (1 to: 100)"
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser column: #one.
	browser showOn: #one; using: [
		browser tree
			tags: [:each | {each even printString} ];
			showOnly: 20].
	^ browser ! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 9/23/2009 13:23'!
treeWithInitialSelection
	"
		| browser |
		browser := self new treeWithInitialSelection. 
		browser openOn: {
			#first->{$a->{}. $c->{}. $d->{}}.
			#second->{$e->{}. $f->{}}. 
			#third->{$h->{}}
		}.
		(browser panes first port: #selection) value: $a->{}.
	"
	|browser |

	browser := GLMTableLayoutBrowser new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			title: 'first tree';
			children: [:x | x value ].
		browser tree
			title: 'second tree';
			children: [:x | x value ]].
	browser showOn: #two; from: #one; using: [ browser text ].
	^ browser! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'tg 11/1/2009 23:26'!
treeWithMenu
	<glmBrowser: 'Tree with Menu' input: '#(($a $b $c $d) ($e $f) ($g $h $i $j $l))'>
	"self new treeWithMenu openOn: #(($a $b $c $d) ($e $f) ($g $h $i $j $l))"
	|browser |

	browser := GLMTableLayoutBrowser new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			children: [:x | x asString size > 1 ifTrue: [x] ifFalse: [OrderedCollection new] ];
			act: [:tree | tree inspect ] entitled: 'Inspect';
			icon: [:x | MenuIcons helpIcon ]].
	browser showOn: #two; from: #one; using: [ browser text ].
	^ browser! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'tg 9/14/2009 21:48'!
updateAction
	<glmBrowser: 'Update Action' input: 'String withAll: ''Select a piece of text and open on the next pane via the contextual menu or by pressing Modifier+o. Otherwise just open the complete copy of the current text on the next pane via the menu or by pressing Modifier+l.'''>
	"self new updateAction openOn: 'Select a piece of text and open on the next pane'"
	| browser |
	browser := GLMFinder new.
	browser text
		update: #selection on: $o entitled: 'Open selection on next pane' with: [:text | text selectedText ];
		update: #selection on: $l entitled: 'Open complete text on next pane' with: [:text | text text ].
	^ browser ! !

!GLMExamples classSide methodsFor: 'as yet unclassified' stamp: 'tg 9/11/2009 15:56'!
browseExamples
	"self browseExamples"
	| browser pragmas |
	pragmas := Pragma 
		allNamed: #glmBrowser:input:
		in: self.
	browser := GLMTableLayoutBrowser new.
	browser title: self name asString.
	browser column: #titles; column: #example span: 4.
	browser showOn: #titles; using: [
		browser list
			format: [:each | each argumentAt: 1]].
	browser showOn: #example; from: #titles; using: [
		browser dynamic
			display: [:each | (self new perform: each selector) startOn: (Compiler evaluate: (each argumentAt: 2) logged: false)]].
	browser openOn: pragmas.! !

GLMExamples subclass: #GLMSmalltalkExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSmalltalkExamples commentStamp: 'tg 9/11/2009 16:10' prior: 0!
self browseExamples!

!GLMSmalltalkExamples methodsFor: 'code' stamp: 'tg 10/23/2009 10:06'!
diffBrowser
	"self new diffBrowser openOn: (Collection withAllSubclasses asOrderedCollection sortBy: [:a :b | a name < b name])"
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser title: 'Glamorous Diff Browser'.
	browser
		row: [:r | r column: #left; column: #right ];
		row: #diff.
	browser showOn: #left; using: [browser custom: self threePaneNavigator ].
	browser showOn: #right; using: [browser custom: self threePaneNavigator ].
	browser showOn: #diff; 
		from: #left->#selectedClass; from: #left->#selectedMethod;
		from: #right->#selectedClass; from: #right->#selectedMethod;
		using: [
		browser diff
			display: [:leftClass :leftMethod :rightClass :rightMethod | 
				Array with: (leftClass sourceCodeAt: leftMethod) with: (rightClass sourceCodeAt: rightMethod)
			]
		].
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'code' stamp: 'tg 9/20/2009 15:48'!
implementorsChasingBrowser
	"self new implementorsChasingBrowser openOn: #implementorsChasingBrowser"
	| finder browser |
	finder := GLMFinder new.
	finder tree
		display: [ :each | self systemNavigation allImplementorsOf:	each ];
		format: [:each | 
			(each isKindOf: MethodReference) ifTrue: [each classSymbol, '>>', each selector ] ifFalse: [ each ]];
		children: [ :each | 
			(each isKindOf: MethodReference) ifTrue: [each compiledMethod messages] ifFalse: [OrderedCollection new]];
		whenKindOf: String.
	browser := GLMTableLayoutBrowser new.
	browser title: [:each | 'Implementors of ', each].
	browser row: #finder; row: #details.
	browser showOn: #finder; using: [browser custom: finder].
	browser showOn: #details; from: #finder; using: [
		browser text
			forSmalltalk: [:reference | reference actualClass ];
			display: [:reference | reference sourceCode ];
			whenKindOf: MethodReference ].
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'objects' stamp: 'tg 9/12/2009 08:49'!
messageTallyFinder
	"self new messageTallyFinder openOn: (
	MessageTally new spyEvery: 1 on: [10000 timesRepeat: [1.23 printString]]; yourself)"

	| browser finder |
	finder := GLMFinder new.
	finder list
		title: 'Messages';
		display: [:each | each sonsOver: -1];
		format: [:each | each printString, ' (', each tally printString, ')'].
	browser := GLMTableLayoutBrowser new.
	browser row: #messages; row: #source.
	browser showOn: #messages; using: [browser custom: finder].
	browser showOn: #source; from: #messages; using: [
		browser text
		title: 'Source';
		display: [:each | each method methodClass sourceCodeAt: each method selector ifAbsent: ['unknown']]
	].
	browser 
		act: [:x |
			(StringHolder new contents: (String streamContents: [:s | x entity report: s; close])) openLabel: 'Spy Results' wrap: false.]
		entitled: 'Print report'.	
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'objects' stamp: 'tg 9/11/2009 16:09'!
messageTallyTree
	<glmBrowser: 'Message Tally Tree' input: 'MessageTally new spyEvery: 1 on: [10000 timesRepeat: [1.23 printString]]; yourself'>
	"self new messageTallyTree openOn: (MessageTally new spyEvery: 1 on: [10000 timesRepeat: [1.23 printString]]; yourself)"

	| browser |
	browser := GLMTableLayoutBrowser new.
	browser column: #messages; column: #details.
	browser showOn: #messages; using: [
		browser tree
			children: [:each | each sonsOver: -1 ];
			format: [:each | Text fromString: (each printString, ' (', each tally printString, ')')]].
	browser showOn: #details; from: #messages; using: [
		browser text
			forSmalltalk: [:each | each method methodClass];
			display: [:each | each method methodClass sourceCodeAt: each method selector ifAbsent: ['unknown']]].
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'others' stamp: 'tg 11/2/2009 04:19'!
metacelloBrowser
	"self new metacelloBrowser openOn: ((Object subclasses select: [:each | each isMetacelloConfig ]) sort: [:a :b | a name < b name])"
	| browser all |

	browser := GLMTableLayoutBrowser new.
	browser title: 'Metacello Browser'.
	browser column: #configs; column: #versions; column: #packages span: 2.
	browser showOn: #configs; using: [
		browser list
			act: [:list  | list selection browse ] entitled: 'Browse implementation';
			act: [:list  | list selection project inspect] entitled: 'Inspect'].
	browser showOn: #versions; from: #configs; using: [
		browser list
			display: [:config | config project versions ];
			format: #versionNumber;
			act: [:list  | list selection inspect] entitled: 'Inspect'.
			 ].
	browser showOn: #packages; from: #versions; using: [
		browser list
			title: 'Items';
			display: [:version | version spec packages packageSpecsInLoadOrder];
			format: #name;
			act: [:list  | list selection inspect] entitled: 'Inspect'.
		browser mondrian
			title: 'Dependencies';
			painting: [:view :version | 
				self viewDependenciesOf: version on: view ].
	 ].
	^ browser ! !

!GLMSmalltalkExamples methodsFor: 'objects' stamp: 'tg 9/6/2009 17:53'!
objectFinder
	"
		self new objectFinder openOn: #(1 2 3 4)
	"
	| browser insideBrowser |
	insideBrowser := GLMTableLayoutBrowser new.
	browser := GLMFinder new.
	browser custom: insideBrowser.
	insideBrowser
		row: #object;
		row: #evaluator.
	insideBrowser
		showOn: #object;
		using: 
			[ insideBrowser list
				title: 'Collection';
				when: [ :anObject | anObject isCollection ].
			insideBrowser list
				title: [ :anObject | self printObjectAsAnItem: anObject ];
				display: 
					[ :anObject | 
					anObject class allInstVarNames collect: [ :iv | iv -> (anObject instVarNamed: iv) ] ];
				format: [ :assoc | assoc key asString , ' : ' , assoc value printString ];
				send: #value ].
	insideBrowser
		showOn: #evaluator;
		using: 
			[ insideBrowser text
				display: [ :entity | 'self' ];
				title: 'Evaluator';
				update: #selection
					on: $o
					entitled: 'Open (o)'
					with: 
						[ :text :entity | 
						Compiler 
							evaluate: text selectedText
							for: entity
							logged: false ] ].
	insideBrowser 
		sendToOutside: #selection
		from: #object.
	insideBrowser 
		sendToOutside: #selection
		from: #evaluator.
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'objects' stamp: 'tg 9/12/2009 01:13'!
objectFinderTabbed
	<glmBrowser: 'Object Finder' input: 'Smalltalk'>
	"
		self new objectFinderTabbed openOn: Smalltalk
	"
	| browser |
	browser := GLMFinder new.
	browser list
		title: [ :anObject | self printObjectAsAnItem: anObject ];
		display: 
			[ :anObject | 
			anObject class allInstVarNames collect: [ :iv | iv -> (anObject instVarNamed: iv) ] ];
		format: [ :assoc | assoc key asString , ' : ' , (assoc value printString copyFrom: 1 to: ((50 min: assoc value printString size) max: 0)) ];
		send: #value.
	browser list
		title: 'Collection';
		when: [ :each | each isCollection ].
	browser text
		forSmalltalk;
		display: [ :entity | 'self' ];
		title: 'Evaluator';
		update: #selection
			on: $o
			entitled: 'Open (o)'
			with: 
				[ :text :entity | 
				Compiler 
					evaluate: text selectedText
					for: entity
					logged: false ];
		act: 
				[ :text :entity | 
				(Compiler 
					evaluate: text selectedText
					for: entity
					logged: false) inspect ]
			on: $/
			entitled: 'Inspect (/)'.
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'private' stamp: 'tg 9/6/2009 17:53'!
printObjectAsAnItem: anObject 
	| title stream |
	stream := String new writeStream.
	title := anObject class name.
	stream
		nextPutAll: (title first isVowel 
				ifTrue: [ 'an ' ]
				ifFalse: [ 'a ' ]);
		nextPutAll: title.
	^ stream contents! !

!GLMSmalltalkExamples methodsFor: 'code' stamp: 'tg 9/13/2009 04:35'!
stClassicBrowser
	<glmBrowser: 'Classic Code Browser' input: 'Smalltalk organization categories'>
	"self new stClassicBrowser openOn: Smalltalk organization categories."
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser
		row: #navigation;
		row: #sourceCode.
	browser
		showOn: #navigation;
		using: [ browser custom: self stClassicNavigator ].
	browser
		showOn: #sourceCode;
		from: #navigation -> #selectedClass;
		from: #navigation -> #selectedMethod;
		from: #navigation -> #selectedClassCategory;
		using: 
			[ browser text
				title: 'Method source';
				display: [ :class :method | class sourceCodeAt: method ];
				forSmalltalk: [ :class | class ].
			browser text
				forSmalltalk;
				useExplicitNotNil;
				title: 'Class definition';
				display: [ :class | class definition ];
				when: [:class | class notNil].
			browser text
				title: 'Class comment';
				display: [ :class | class comment ];
				useExplicitNotNil;
				when: [:class | class notNil]
		].
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'code' stamp: 'tg 10/30/2009 15:41'!
stClassicNavigator
	"self new stClassicNavigator openOn: Smalltalk organization categories."
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser
		column: #classCats;
		column: #classes;
		column: #categories;
		column: #methods.
	browser
		showOn: #classCats;
		using: 
			[ browser list ].
	browser
		showOn: #classes;
		from: #classCats;
		using: [
			browser tree
				display: [ :classCat | 
					(Smalltalk organization listAtCategoryNamed: classCat) collect: [ :className | Smalltalk classNamed: className ] ];
				children: [ :each | each traitComposition traits ];
				title: 'Class list'.
			browser mondrian 
				painting: [ :view :package |
					view nodes: ((Smalltalk organization listAtCategoryNamed: package) collect: [:name | Smalltalk classNamed: name]).
					view edgesFrom: #superclass.
					view treeLayout.];
				title: 'Hierarchy'.
 ].
	browser
		showOn: #categories;
		from: #classes;
		using: [ browser list display: [ :class | class organization categories ] ].
	browser
		showOn: #methods;
		from: #classes;
		from: #categories;
		using: 
			[ browser list
				display: 
					[ :class :category | 
					(class organization listAtCategoryNamed: category) asSortedCollection].
			browser list
				useExplicitNotNil;
				when: [ :class :category | class notNil and: [ category isNil ] ];
				display: [ :class :category | class selectors asSortedCollection ] ].
	browser 
		sendToOutside: #selectedClassCategory
		from: #classCats.
	browser 
		sendToOutside: #selectedClass
		from: #classes.
	browser 
		sendToOutside: #selectedMethod
		from: #methods.
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'code' stamp: 'tg 9/14/2009 11:16'!
stMultiPanedBrowser
	<glmBrowser: 'Multi-paned Code Browser' input: 'GLMSTClassCategory all'>
	"self new stMultiPanedBrowser openOn: GLMSTClassCategory all"
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser title: 'Glamorous Smallalk Browser'.
	browser
		column: #navigation;
		column: #sourceCode.
	browser
		showOn: #navigation;
		using: [ browser custom: self stMutiPanedNavigator ].
	browser
		showOn: #sourceCode;
		from: #navigation -> #selectedClass;
		from: #navigation -> #selectedMethod;
		from: #navigation -> #selectedClassCategory;
		using: 
			[ browser text
				title: [:class :method | method glmBehavior isMetaSide ifTrue: ['Meta-side method'] ifFalse: ['Instance-side method']];
				display: [ :class :method | method sourceCode ];
				when: [ :class :method | method notNil and: [ method isMethod ] ];
				forSmalltalk: [ :class | class stBehavior ].
			browser text
				forSmalltalk;
				title: 'Class definition';
				display: [ :class | class definition ];
				useExplicitNotNil;
				when: [ :class | class notNil ] ].
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'code' stamp: 'tg 9/15/2009 01:08'!
stMutiPanedNavigator
	"
		self new stMutiPanedNavigator openOn: GLMSTClassCategory all
	"
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser
		column: #classCats;
		column: 
			[ :c | 
			c
				row: #classes
					span: 2;
				row: #classComment ];
		column: 
			[ :c | 
			c
				row: #instanceMethods
					span: 2;
				row: #metaMethods ].
	browser
		showOn: #classCats;
		using: 
			[ browser list
				display: [ :categories | categories sort: [ :a :b | a name < b name ] ];
				filterOn: [ :text :list | list select: [ :each | text match: each name ] ] ].
	browser
		showOn: #classes;
		from: #classCats;
		using: 
			[ browser tree
				display: [ :classCat | classCat classes ];
				children: [ :each | each traits ];
				icon: 
					[ :each | 
					each stBehavior theNonMetaClass browserIcon isNil 
						ifFalse: 
							[ OBMorphicIcons iconNamed: each stBehavior theNonMetaClass browserIcon ]
						ifTrue: [ nil ] ] ].
	browser
		showOn: #classComment;
		from: #classes;
		using: [ browser text display: [ :class | class comment ] ].
	browser
		showOn: #instanceMethods;
		from: #classes;
		using: 
			[ browser tree
				display: [ :class | class protocols ];
				children: 
					[ :catOrMethod | 
					catOrMethod isCategory 
						ifTrue: [ catOrMethod methods ]
						ifFalse: [ OrderedCollection new ] ];
				send: 
					[ :catOrMethod | 
					(catOrMethod notNil and: [ catOrMethod isCategory ]) 
						ifTrue: [ nil ]
						ifFalse: [ catOrMethod ] ] ].
	browser
		showOn: #metaMethods;
		from: #classes;
		using: 
			[ browser tree
				display: [ :class | class metaSide protocols ];
				children: 
					[ :catOrMethod | 
					catOrMethod isCategory 
						ifTrue: [ catOrMethod methods ]
						ifFalse: [ OrderedCollection new ] ];
				send: 
					[ :catOrMethod | 
					(catOrMethod notNil and: [ catOrMethod isCategory ]) 
						ifTrue: [ nil ]
						ifFalse: [ catOrMethod ] ] ].
	browser 
		sendToOutside: #selectedClassCategory
		from: #classCats.
	browser 
		sendToOutside: #selectedClass
		from: #classes.
	browser 
		sendToOutside: #selectedMethod
		from: #instanceMethods.
	browser 
		sendToOutside: #selectedMethod
		from: #metaMethods.
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'code' stamp: 'tg 10/23/2009 09:18'!
threePaneNavigator	
	| classBrowser |
	classBrowser := GLMTableLayoutBrowser new.
	classBrowser column: #classes; column: #methods.
	classBrowser showOn: #classes; using: [classBrowser list].
	classBrowser showOn: #methods; from: #classes; using: [
		classBrowser list
			display: [:cls | cls selectors asOrderedCollection sortBy: [:a :b | a < b]]].
	classBrowser sendToOutside: #selectedClass from: #classes.
	classBrowser sendToOutside: #selectedMethod from: #methods.
	^ classBrowser! !

!GLMSmalltalkExamples methodsFor: 'code' stamp: 'tg 9/1/2009 16:25'!
traitsBrowser
	| browser codeBrowser |
	browser := GLMFinder new.
	browser list
		title: 'Classes'; 
		when: [:anObject | anObject isCollection and: [anObject anyOne isKindOf: Class]].
	browser list
		title: 'Methods';
		display: [:anObject | anObject selectors collect: [:each | anObject -> each ]];
		format: [:each | each value];
		when: [:anObject | (anObject isKindOf: Class) or: [anObject isKindOf: Trait]].
	browser list
		title: 'Traits';
		when: [:anObject | (anObject isKindOf: Class) or: [anObject isKindOf: Trait]];
		display: [:anObject | anObject traitComposition traits ].
	codeBrowser := GLMTableLayoutBrowser new.
	codeBrowser row: [:r | r column: #classes; column: #internals]; row: #details.
	codeBrowser showOn: #classes; using: [codeBrowser list].
	codeBrowser showOn: #internals; from: #classes; using: [codeBrowser custom: browser].
	codeBrowser showOn: #details; from: #internals; using: [
		codeBrowser text
			when: [:trait | trait isKindOf: Trait];
			display: [:trait | trait comment].
		codeBrowser text
			forSmalltalk;
			when: [:trait | trait isKindOf: Trait];
			display: [:trait | trait definition].
		codeBrowser text
			forSmalltalk: [:assoc | assoc key];
			when: [:assoc | (assoc isKindOf: Association)];
			display: [:assoc | assoc key sourceCodeAt: assoc value]].
	codeBrowser openOn: NSCollectionStream withAllSubclasses! !

!GLMSmalltalkExamples methodsFor: 'private' stamp: 'tg 11/2/2009 04:15'!
viewDependenciesOf: version on: view
	| all | 
	all := Dictionary new.
	version packages do: [:each | all at: each name put: each].
	version projects do: [:each | all at: each name put: each].
	view shape label text: [:each | each name ].
	view nodes: all values.
	view shape curvedLine.
	view edges: version packages from: [:eachPackage | all at: eachPackage name] toAll: [:eachPackage |
		eachPackage requires collect: [:each | all at: each ]].
	view horizontalDominanceTreeLayout! !

Object subclass: #GLMFile
	instanceVariableNames: 'pathName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMFile commentStamp: 'DamienCassou 9/2/2009 19:52' prior: 0!
This is a very simple and limited implementation of the java.io.File class. I did that because FileDirectory is just impossible to use and remember. !

!GLMFile classSide methodsFor: 'accessing' stamp: 'DamienCassou 9/23/2009 08:15'!
anyRoot
	^ self roots detect: [:file | [file files notEmpty] on: Error do: [false]] ! !

!GLMFile classSide methodsFor: 'instance creation' stamp: 'DamienCassou 9/23/2009 08:15'!
pathName: aString
	^ self new
		setPathName: aString;
		yourself ! !

!GLMFile classSide methodsFor: 'accessing' stamp: 'DamienCassou 9/23/2009 08:15'!
roots
	^ (OSPlatform current platformFamily = #Windows)
		ifTrue: [FileDirectory root fileAndDirectoryNames collect: [:ea | self pathName: ea]]
		ifFalse: [Array with: (self pathName: FileDirectory root fullName)]! !

!GLMFile methodsFor: 'reading' stamp: 'DamienCassou 9/3/2009 10:55'!
contents
	self isFile not ifTrue: [Error signal: 'Only files have content'].
	^ FileStream
		readOnlyFileNamed: pathName
		do: [:stream | stream contents]! !

!GLMFile methodsFor: 'enumerating' stamp: 'DamienCassou 9/22/2009 18:50'!
files
	^ ([(FileDirectory on: pathName) fileAndDirectoryNames]
		on: InvalidDirectoryError do: [:err | Array new])
			collect: [:name | self class pathName: ((FileDirectory on: pathName) fullNameFor: name)]! !

!GLMFile methodsFor: 'testing' stamp: 'DamienCassou 9/2/2009 18:57'!
isDirectory
	^ (pathName = '/') or: [(FileDirectory on: pathName) directoryEntry isDirectory]! !

!GLMFile methodsFor: 'testing' stamp: 'DamienCassou 9/2/2009 19:00'!
isFile
	^ self isDirectory not! !

!GLMFile methodsFor: 'printing' stamp: 'DamienCassou 9/22/2009 19:05'!
name
	^ self tail! !

!GLMFile methodsFor: 'printing' stamp: 'DamienCassou 9/2/2009 19:19'!
nameDistinguishingTypes
	^ self isDirectory 
		ifTrue: [self name, '/']
		ifFalse: [self name]! !

!GLMFile methodsFor: 'printing' stamp: 'DamienCassou 9/22/2009 19:06'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self tail;
		nextPut: $)! !

!GLMFile methodsFor: 'private' stamp: 'DamienCassou 9/2/2009 18:35'!
setPathName: aString
	pathName := aString! !

!GLMFile methodsFor: 'printing' stamp: 'DamienCassou 9/22/2009 19:10'!
tail
	| name |
	name := (FileDirectory on: pathName) localName.
	^ name isEmpty
		ifTrue: [pathName]
		ifFalse: [name]! !

Object subclass: #GLMSTBrowserExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTBrowserExample methodsFor: 'accessing' stamp: 'tg 8/31/2009 17:00'!
browser
	"
	self new browser openOn: (BrowserEnvironment new forPackageNamed: 'Glamour')
	"

	| browser |

	browser := GLMTableLayoutBrowser new.
	browser row: [ :row | 
		row 
			column: #category;
			column: #class;
			column: #protocol;
			column: #selector ].
	browser row: #source.
	
	" categories "
	self categoriesOn: browser.
	self classesOn: browser.
	self protocolsOn: browser.
	self selectorsOn: browser.
	self sourceOn: browser.
	
	^ browser! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 2/27/2009 15:09'!
categoriesOn: browser
	browser showOn: #category; using: [
		browser list
			display: [ :environment | environment categories ] ]! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 2/27/2009 15:09'!
classesOn: browser
	browser showOn: #class; from: #outer -> #entity; from: #category; using: [
		browser list
			title: 'Instance';
			display: [ :environment :category | 
				((environment classes select: [ :each | each isMeta not ])
					select: [ :each | each category = category ])
					asSortedCollection: [ :a :b | a name < b name ] ];
			format: [ :class | class name ].
		browser list
			title: 'Class';
			display: [ :environment :category | 
				((environment classes select: [ :each | each isMeta ])
					select: [ :each | each theNonMetaClass category = category ])
					asSortedCollection: [ :a :b | a name < b name ] ];
			format: [ :class | class theNonMetaClass name ] ]! !

!GLMSTBrowserExample methodsFor: 'accessing' stamp: 'lr 2/27/2009 10:35'!
model
	^ BrowserEnvironment new forPackageNamed: 'Glamour'! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 2/27/2009 15:08'!
protocolsOn: browser
	browser showOn: #protocol; from: #outer -> #entity; from: #class; using: [
		browser list
			when: [ :environment :class | class notNil ];
			display: [ :environment :class | 
				(environment protocolsFor: class)
					asSortedCollection ] ]! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'tg 8/31/2009 00:12'!
selectorsOn: browser
	browser showOn: #selector; from: #outer -> #entity; from: #class; from: #protocol; using: [
		browser list
			when: [ :environment :class :protocol | class notNil and: [ protocol notNil ] ];
			display: [ :environment :class :protocol | (environment selectorsFor: protocol in: class) asOrderedCollection ].
		browser list
			when: [ :environment :class :protocol | class notNil and: [ protocol isNil ] ];
			display: [ :environment :class :protocol | (environment selectorsForClass: class) asOrderedCollection ] ]! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 3/12/2009 15:00'!
sourceOn: browser
	browser showOn: #source; from: #category; from: #class; from: #selector; using: [
		browser text
			title: 'Source';
			when: [ :category :class :selector | class notNil and: [ selector notNil ] ];
			display: [ :category :class :selector | class sourceCodeAt: selector ifAbsent: [ String new ] ].
		browser text
			title: 'Source';
			when: [ :category :class :selector | class notNil and: [ selector isNil ] ];
			display: [ :category :class :selector | class definition ].
		browser mondrian
			title: 'Complexity';
			painting: [ :view :category :class :selector |
				view nodeShape 
					height: [ :model | model linesOfCode min: 50 max: 5 ];
					width: [ :model | model instVarNames size + 5 ];
					fillColor: [ :model | model = class ifTrue: [ Color red ] ifFalse: [ Color white ] ].
				view nodes: ((Smalltalk organization listAtCategoryNamed: category)
					collect: [ :each | Smalltalk classNamed: each ]).
				view edgesFrom: [ :each | each superclass ].
				view treeLayout ];
			when: [ :category :class :selector | category notNil ] ]! !

Object subclass: #GLMSTModel
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTModel classSide methodsFor: 'defaults' stamp: 'DamienCassou 9/14/2009 08:43'!
defaultEnvironment
	^ BrowserEnvironment new! !

!GLMSTModel methodsFor: 'accessing' stamp: 'tg 9/18/2009 11:46'!
= anObject
	^ self class = anObject class and: [self name = anObject name ]! !

!GLMSTModel methodsFor: 'accessing' stamp: 'tg 9/18/2009 11:42'!
environment
	^ environment ifNil: [environment := self class defaultEnvironment]! !

!GLMSTModel methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:42'!
environment: anObject
	environment := anObject! !

!GLMSTModel methodsFor: 'testing' stamp: 'tg 9/6/2009 16:16'!
isCategory
	^ false! !

!GLMSTModel methodsFor: 'testing' stamp: 'tg 9/6/2009 19:01'!
isClass
	^ false! !

!GLMSTModel methodsFor: 'testing' stamp: 'tg 9/6/2009 19:01'!
isClassCategory
	^ false! !

!GLMSTModel methodsFor: 'testing' stamp: 'tg 9/6/2009 19:01'!
isMethod
	^ false! !

!GLMSTModel methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:46'!
name
	self subclassResponsibility! !

!GLMSTModel methodsFor: 'printing' stamp: 'tg 9/6/2009 16:12'!
printOn: aStream
	aStream nextPutAll: self name! !

GLMSTModel subclass: #GLMSTNamedModel
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

GLMSTNamedModel subclass: #GLMSTBehavior
	instanceVariableNames: 'stBehavior instanceAndMetaMethods methods instVars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTBehavior classSide methodsFor: 'instance creation' stamp: 'DamienCassou 9/14/2009 08:52'!
behavior: aBehavior environment: anEnvironment
	^ self new
		stBehavior: aBehavior;
		environment: anEnvironment;
		yourself! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:38'!
comment
	^ self stBehavior comment! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:38'!
definition
	^ self stBehavior definition! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/18/2009 11:41'!
glmPackage
	^ GLMSTPackage named: (PackageOrganizer default mostSpecificPackageOfClass: self stBehavior) packageName environment: self environment! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/18/2009 09:52'!
instVars
	^ instVars ifNil: [
		instVars := self stBehavior instVarNames collect: [:each | 
			GLMSTVariable new name: each; glmBehavior: self; yourself ] ]! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/15/2009 00:33'!
instanceAndMetaMethods
	^ instanceAndMetaMethods ifNil: [ instanceAndMetaMethods := (self methods, self metaSide methods) asSortedCollection: [:a :b | a name < b name] ]! !

!GLMSTBehavior methodsFor: 'testing' stamp: 'tg 9/14/2009 11:14'!
isMetaSide 
	^ self stBehavior class = Metaclass ! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/19/2009 09:46'!
metaSide
	^ (GLMSTClass named: self name) 
		stBehavior: self stBehavior class;
		yourself! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/15/2009 01:11'!
methods
	^ methods ifNil: [
		methods := OrderedCollection new.
		self protocols do: [:each |
			methods addAll: each methods ].
		methods ]! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:12'!
name
	^ self stBehavior name! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 09:04'!
protocols
	^ (self environment protocolsFor: self stBehavior) collect: 
		[ :each | 
		GLMSTProtocol new
			name: each;
			glmBehavior: self;
			yourself ]! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/18/2009 11:16'!
references
	| association |
	association := Smalltalk associationAt: self name ifAbsent: [ ^ #() ].
	^ (self systemNavigation allCallsOn: association) collect: [ :each |
		GLMSTMethod fromMethodReference: each ]! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:39'!
sourceCodeAt: aSelector
	^ self stBehavior sourceCodeAt: aSelector! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:54'!
stBehavior
	^ stBehavior! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 09:27'!
stBehavior: anObject
	stBehavior := anObject! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:55'!
traits
	^ self stBehavior traitComposition traits collect: [:each |
		GLMSTTrait new stBehavior: each; yourself]! !

GLMSTBehavior subclass: #GLMSTClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

GLMSTBehavior subclass: #GLMSTTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

GLMSTNamedModel subclass: #GLMSTClassCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTClassCategory classSide methodsFor: 'as yet unclassified' stamp: 'DamienCassou 9/14/2009 09:42'!
all
	|environment|
	environment := self defaultEnvironment.
	^ environment categories collect: [:each | self named: each environment: environment]! !

!GLMSTClassCategory methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 09:43'!
classes
	^ (Smalltalk organization listAtCategoryNamed: self name) collect: [ :className |
		GLMSTClass behavior: (Smalltalk classNamed: className) environment: self environment]! !

GLMSTNamedModel subclass: #GLMSTMethod
	instanceVariableNames: 'glmCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTMethod classSide methodsFor: 'as yet unclassified' stamp: 'tg 9/18/2009 11:21'!
fromMethodReference: aMethodReference
	| cls cat |
	cls := GLMSTClass new.
	cls stBehavior: (Smalltalk at: aMethodReference classSymbol).
	cat := GLMSTProtocol new.
	cat name: aMethodReference category.
	cat glmBehavior: cls.
	^ GLMSTMethod new
		name: aMethodReference methodSymbol;
		glmCategory: cat;
		yourself! !

!GLMSTMethod methodsFor: 'accessing' stamp: 'tg 9/14/2009 11:16'!
glmBehavior 
	^ self glmCategory glmBehavior ! !

!GLMSTMethod methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:42'!
glmCategory
	^ glmCategory! !

!GLMSTMethod methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:42'!
glmCategory: anObject
	glmCategory := anObject! !

!GLMSTMethod methodsFor: 'accessing' stamp: 'tg 9/18/2009 10:58'!
implementors
	^ (self systemNavigation allImplementorsOf:	self name) collect: [:each | 
			GLMSTMethod fromMethodReference: each ]! !

!GLMSTMethod methodsFor: 'testing' stamp: 'tg 9/6/2009 19:01'!
isMethod
	^ true! !

!GLMSTMethod methodsFor: 'accessing' stamp: 'tg 9/18/2009 10:58'!
senders
	^ (self systemNavigation allSendersOf:	self name) collect: [:each | 
			GLMSTMethod fromMethodReference: each ]! !

!GLMSTMethod methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:59'!
sourceCode
	^ self glmCategory glmBehavior sourceCodeAt: self name! !

!GLMSTNamedModel classSide methodsFor: 'instance creation' stamp: 'DamienCassou 9/14/2009 08:47'!
named: aString
	^ self named: aString environment: self defaultEnvironment! !

!GLMSTNamedModel classSide methodsFor: 'instance creation' stamp: 'DamienCassou 9/14/2009 08:47'!
named: aString environment: anEnvironment
	^ self new
		name: aString;
		environment: anEnvironment;
		yourself! !

!GLMSTNamedModel methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:45'!
name
	^ name! !

!GLMSTNamedModel methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:45'!
name: anObject
	name := anObject! !

GLMSTNamedModel subclass: #GLMSTPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTPackage classSide methodsFor: 'instance creation' stamp: 'DamienCassou 9/14/2009 08:51'!
named: aString environment: anEnvironment
	^ self new
		name: aString;
		environment: anEnvironment;
		yourself! !

!GLMSTPackage classSide methodsFor: 'instance creation' stamp: 'DamienCassou 9/13/2009 11:26'!
rootPackagesOn: anEnvironment
	^ ((anEnvironment categories collect: [:name | name readStream upTo: $-]) asSet asSortedCollection)
			collect: [:name | self named: name environment: anEnvironment]! !

!GLMSTPackage methodsFor: 'accessing' stamp: 'tg 9/18/2009 11:50'!
allClasses
	| all |
	all := self classes asOrderedCollection.
	self subPackages do: [:each | 
		all addAll: each allClasses ].
	^ all! !

!GLMSTPackage methodsFor: 'accessing' stamp: 'tg 9/18/2009 11:38'!
classes
	^ (self environment classNamesFor: self name)
		collect: [:className | GLMSTClass behavior: (self environment at: className) environment: self environment ]! !

!GLMSTPackage methodsFor: 'accessing' stamp: 'DamienCassou 9/13/2009 11:39'!
subPackages
	^ self environment categories
		select: [:name | name beginsWith: self name, '-']
		thenCollect: [:name | self class named: name environment: self environment]! !

GLMSTNamedModel subclass: #GLMSTProtocol
	instanceVariableNames: 'glmBehavior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTProtocol methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:59'!
glmBehavior
	^ glmBehavior! !

!GLMSTProtocol methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 09:00'!
glmBehavior: anObject 
	glmBehavior := anObject! !

!GLMSTProtocol methodsFor: 'testing' stamp: 'tg 9/6/2009 16:16'!
isCategory
	^ true! !

!GLMSTProtocol methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:59'!
methods
	^ (self glmBehavior stBehavior organization listAtCategoryNamed: self name) asSortedCollection collect: 
		[ :each | 
		GLMSTMethod new
			name: each;
			glmCategory: self;
			yourself ]! !

GLMSTNamedModel subclass: #GLMSTVariable
	instanceVariableNames: 'glmBehavior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTVariable methodsFor: 'accessing' stamp: 'tg 9/18/2009 10:47'!
accessingMethods
	| selectors |
	selectors := self glmBehavior stBehavior whichSelectorsAccess: self name.
	^ self glmBehavior methods select: [:each | selectors includes: each name ]! !

!GLMSTVariable methodsFor: 'accessing' stamp: 'tg 9/18/2009 09:38'!
glmBehavior
	^ glmBehavior! !

!GLMSTVariable methodsFor: 'accessing' stamp: 'tg 9/18/2009 09:38'!
glmBehavior: anObject
	glmBehavior := anObject! !
